package log

// LEVEL represents a logging level (e.g. info, warn, ...).
type LEVEL uint8

const (
	// Available log levels.
	NONE  LEVEL = 0
	PANIC LEVEL = 1
	FATAL LEVEL = 50
	ERROR LEVEL = 100
	WARN  LEVEL = 150
	INFO  LEVEL = 200
	DEBUG LEVEL = 250
	ALL   LEVEL = ^LEVEL(0)
)

// Levels represents a lookup table of log levels to strings.
type levels [int(ALL) + 1]string

// defaultLevels is a lookup table of default log levels.
var defaultLevels = levels{
	PANIC: "PANIC",
	FATAL: "FATAL",
	ERROR: "ERROR",
	WARN:  "WARN",
	INFO:  "INFO",
	DEBUG: "DEBUG",
}
